<?php

function process($code) {
    $mem = array_fill(0, 256, 0);
    
    $ip = 0;
    $di = 0;
    
    $output = "";

    for ($steps = 0; $steps < 10000; $steps++) {
      if ($ip >= strlen($code)) {
        break;
      }

      switch ($code[$ip]) {
        case '>':
          $di = ($di + 1) % count($mem);
        break;
        case '<':
          $di = ($di - 1 + count($mem)) % count($mem);
        break;
        case '+':
          $mem[$di] = ($mem[$di] + 1) % 256;
        break;
        case '-':
          $mem[$di] = ($mem[$di] - 1 + 256) % 256;
        break;
        case '.':
          $output .= chr($mem[$di]);
        break;
        case ',':
          $mem[$di] = 0;
        break;
        case '[':
          if ($mem[$di] == 0) {
            $brkNest = 1;
            while ($brkNest > 0 && ++$ip < strlen($code)) {
              if ($code[$ip] == '[') {
                $brkNest++;
              } elseif ($code[$ip] == ']') {
                $brkNest--;
              }
            }
            if ($brkNest > 0) {
              exit("Can't find where to jump\n");
            }
          }
        break;
        case ']':
          if ($mem[$di] != 0) {
            $brkNest = 1;
            while ($brkNest > 0 && --$ip >= 0) {
              if ($code[$ip] == ']') {
                $brkNest++;
              } elseif ($code[$ip] == '[') {
                $brkNest--;
              }
            }
            if ($brkNest > 0) {
              exit("Can't find where to jump\n");
            }
          }
        break;
      }

      $ip++;
    }
    
    return $output;
}
    
?>